window.onload = function () {
    //SVG VARs
  var svg = Snap("#CLOCK_SVG"),
    //exagon_group = Snap.select("#EXAGON"),
    exagon = Snap.select("#EXAGON_PATH"),
    exagon_ind = Snap.select("#EXAGON_INDICATOR"),
    exagon_ind_sun = Snap.select("#EXAGON_INDICATOR_SUN"),
    exagon_ind_mask_ampm = Snap.select("#EXAGON_INDICATOR_MASK_AMPM"),
    triangle_group = Snap.select("#TRIANGLE"),
    triangle = Snap.select("#TRIANGLE_PATH"),
    triangle_ind = Snap.select("#TRIANGLE_INDICATOR"),
    //triangle_ind_1 = Snap.select("#TRIANGLE_INDICATOR_1"),
    triangle_ind_2 = Snap.select("#TRIANGLE_INDICATOR_2"),
    five_min_ind = Snap.select("#FIVE_MINUTES_LINES"),
    minutes_ind = Snap.select("#MINUTES_POINTS"),
    sunset_layer = Snap.select("#SUNSET_LAYER"),
    seconds_ind = svg.line(100,31,100,25);
    seconds_ind.attr({
      stroke: "#fff",
      strokeWidth: 1
    });

  //VARs
var exagon_indicator_coordinates = ["0, 0", "77, 45", "77, 134", "0, 180", "-77, 134", "-77, 45"],

  //COLORS
    //exagon_daycolor = "#e40050",
    //exagon_nightcolor = "#e40050" //"#94042c",
    exagon_color = "#e40050";
    triangle_daycolor = "#ffffff",
    triangle_dayopacity = "1",
    triangle_nightcolor = "#000000",
    triangle_nightopacity = "0.3",

    triangle_ind_daycolor = "#000000",
    triangle_ind_dayopacity = ".45",
    triangle_ind_nightcolor = "#000000",
    triangle_ind_nightopacity = ".65",

    five_min_ind_dayopacity = ".4",
    five_min_ind_nightopacity = ".7",
    minutes_ind_dayopacity = ".4",
    minutes_ind_nightopacity = ".7",

    indicator_sun_color = "#ffffff",
    indicator_moon_color = "#ffffff",

 //CONF
    color = exagon_color;
    sunrise_time = 6,
    sunset_time = 18,
    show_seconds = false;

  function getUrlVars() {
      var vars = {};
      var parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value) {
      vars[key] = value;});
      return vars;
    }

  function changeColor(color) {
      exagon.animate({fill: color}, 10);
      exagon_ind_mask_ampm.animate({fill: color}, 10);
      colorpicker = document.getElementById("colorpicker");
      colorpicker.value = color.replace('#','');
      colorpicker.style.backgroundColor = color;
  }

  function sunset(duration) {
      sunset_layer.animate({opacity: 0.3}, duration, mina.easeout);
      exagon_ind_mask_ampm.animate({opacity: 1}, duration, mina.easeout);
      exagon_ind_sun.animate({fill: indicator_moon_color}, duration, mina.easeout);
      triangle.animate({fill: triangle_nightcolor, opacity: triangle_nightopacity}, duration, mina.easeout);
      triangle_ind.animate({fill: triangle_ind_nightcolor, opacity: triangle_ind_nightopacity}, duration, mina.easeout);
  }
  function sunrise(duration) {
      sunset_layer.animate({opacity: 0}, duration, mina.easeout);
      exagon_ind_sun.animate({fill: indicator_sun_color}, duration, mina.easeout);
      exagon_ind_mask_ampm.animate({opacity: 0}, duration, mina.easeout);
      triangle.animate({fill: triangle_daycolor, opacity: triangle_dayopacity}, duration, mina.easeout);
      triangle_ind.animate({fill: triangle_ind_daycolor, opacity: triangle_ind_dayopacity}, duration, mina.easeout);
  }

  function updateSecond(second) {
      s = new Snap.Matrix();
      s.rotate(second * 6, 100, 100);
      seconds_ind.transform(s);
      delete s;
  }

  function updateMinute(minute, first_time) {
      if (first_time) {
          minute_angle = minute * 12;
          spin_duration = 300 + (minute_angle / 360) * 220; //more indipendent animation duration by the current angle
          triangle_group.animate({transform:"r" + (minute * 12) % 360 + ", 100, 100"}, spin_duration, mina.backout);
          delete minute_angle; delete spin_duration;
        }
      else
          triangle_group.animate({transform:"r" + (minute * 12) + ", 100, 100"}, 1000, mina.backout);

      if ((first_time) ? (minute > 29) : (minute == 30))
         triangle_ind_2.animate({opacity: 1}, (first_time) ? (0) : (300), mina.elastic);
      else if ((first_time) ? (minute < 30) : (minute == 0))
         triangle_ind_2.animate({opacity: 0}, (first_time) ? (0) : (300), mina.elastic);
  }

  function updateHour(hour, first_time) {
      exagon_ind.animate({transform:"t" + exagon_indicator_coordinates[hour % 6]}, 300, mina.bounce);
      if (!first_time && hour == sunset_time)
          sunset(10000);
      else if (!first_time && hour == sunrise_time)
          sunrise(10000);
  }

  function updateClock(second, minute, hour, first_time) {
      if (!second) second = date.getSeconds();
      if (!minute) minute = date.getMinutes();
      if (!hour) hour = date.getHours();
      if (first_time)
        (hour < sunrise_time || hour >= sunset_time) ? (sunset(0)) : (sunrise(0));
      updateMinute(minute, first_time);
      updateHour(hour, first_time);
      (!show_seconds) ? (seconds_ind.attr({opacity: '0'})) : (updateSecond(second, first_time));
      delete second; delete minute; delete hour;
  }

  //QUANDO CAMBIO COLORE CAMBIO LO AGGIUNGO O CAMBIO COME PARAMETRO URL E GLIELO RIMETTO?

      first_time = true;
      var url_vars = getUrlVars();
      date = new Date();

      // URL VARIABLES
          // OFFSET (LIKE ZONES)
          if (url_vars['o'])
            offset = url_vars['o'] % 24;
          else
            offset = 0;

          // STATIC HOUR
          if (url_vars['h']) {
            hour = url_vars['h'] % 24;
            still = true;}
          else {
            hour = date.getHours();
            still = false;}

          // STATIC MINUTE
          if (url_vars['m']) {
            minute = url_vars['m'] % 60;
            still = true;}
          else {
            minute = date.getMinutes();
            still = false;}

          // STATIC SECOND
          if (url_vars['s']) {
            second = url_vars['s'] % 60;
            still = true;}
          else {
            second = date.getSeconds();
            still = false;}

          // COLOR
          if (url_vars['c'])
            color = url_vars['c'];
          else
            color = exagon_color;

          // SHOW SECONDS
          if (url_vars['showsec'] && url_vars['showsec'] == 'true')
            show_seconds = true;

          changeColor(color);
          first_interval = (show_seconds) ? ((1000 - (60 - date.getSeconds()) * 1000)) : ((60 - date.getSeconds()) * 1000); //seconds remaining to next minute
          interval = (show_seconds) ? (1000) : (60000);
          updateClock(second, minute, hour + offset, first_time);
          if (!still) {
            window.setInterval(function() {
                date = new Date();
                if (show_seconds)
                  updateClock(date.getSeconds(), date.getMinutes(), date.getHours() + offset);
                else
                  updateClock(0, date.getMinutes(), date.getHours() + offset);

                delete date;
            }, (first_time) ? (first_interval) : (interval));
            delete first_time; delete first_interval;
          }

  };

// END OF GLOCK

// HOW-TO SLIDESHOW

function HowTo(option) {
  ht1 = document.getElementById("HT1"),
  ht2 = document.getElementById("HT2"),
  ht3 = document.getElementById("HT3"),
  ht4 = document.getElementById("HT4");
  ht5 = document.getElementById("HT5");

  if (option == '1')
      ht1.className = "HowTo active";
  else if (option == '2') {
      ht1.className = "HowTo inactive";
      ht2.className = "HowTo active"
    }
  else if (option == '3') {
      ht2.className = "HowTo inactive";
      ht3.className = "HowTo active";
    }
  else if (option == '4') {
      ht3.className = "HowTo inactive";
      ht4.className = "HowTo active";
    }
    else if (option == '5') {
      ht4.className = "HowTo inactive";
      ht5.className = "HowTo active";
      }
  else {
      ht1.className = "HowTo inactive";
      ht2.className = "HowTo inactive";
      ht3.className = "HowTo inactive";
      ht4.className = "HowTo inactive";
      ht5.className = "HowTo inactive";
    }
  delete ht1; delete ht2; delete ht3; delete ht4;
  }

function show_credits() {
    credits = document.getElementById("credits");
    credits.className = "HowTo active";
    delete credits;
  }
function close_credits() {
    credits = document.getElementById("credits");
    credits.className = "HowTo inactive";
    delete credits;
  }

function toggle_colorpicker() {
    picker = document.getElementById("colorpicker");
    picker.className == "jscolor active" ? (picker.className = "jscolor inactive") : (picker.className = "jscolor active");
    delete picker;
}
